[English](/README.md) | 中文
# OpenHub 
[![Releases](https://img.shields.io/badge/android-5.0%2B-brightgreen.svg)](https://play.google.com/store/apps/details?id=com.thirtydegreesray.openhub)
[![Releases](https://img.shields.io/github/release/ThirtyDegreesRay/OpenHub.svg)](https://github.com/ThirtyDegreesRay/OpenHub/releases/latest)

一个**开源**的GitHub Android客户端应用，快速简洁。

[![Coolapk](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/coolapk.png?raw=true)](https://www.coolapk.com/apk/com.thirtydegreesray.openhub)
[![Google Play](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/google_play.png?raw=true)](https://play.google.com/store/apps/details?id=com.thirtydegreesray.openhub)

## 特点

### App
* 一种登录方式(OAuth)
* 支持夜间模式和AMOLED Dark主题，多种主色调
* 支持Markdown和代码高亮
* 支持英文、简体中文、希伯来文、德文、印地文、葡萄牙文、韩文、西班牙文、繁体中文、俄罗斯文、波兰文, 格鲁吉亚文、意大利文、荷兰文、捷克文和葡萄牙文（巴西）
* 支持离线模式
* 支持所有语言的最热版本库查看
* 支持多账户切换
* 搜索版本库和用户
* 支持7.1以上快捷方式创建
* 支持消息通知
* 支持添加用户、版本库书签
* 自动记录浏览过的用户和版本库
* 查看 github 集合(collections)
* 查看 github 精选主题(featured topics)
* 支持在移动网络下禁用图片加载

### 版本库
* 查看版本库信息和版本库分支
* 星标、关注和fork版本库
* 查看版本库文件、提交信息和活动
* 下载源码、发布版本和文件
* 查看你所有的版本库，包括公开、私有、fork的，以及星标的
* 查看每日、每周和每月的最热版本库
* 搜索版本库
* 查看Wiki最近更新

### 用户
* 查看用户信息
* 查看用户的跟随者、跟随的人和属于的组织
* 查看用户公共的、星标的项目和活动
* 查看你的私有项目
* 跟随和取消跟随用户
* 搜索用户

### 组织
* 查看组织信息
* 查看组织的公开版本库和活动
* 查看组织成员

### 问题
* 查看问题信息、评论和事件
* 创建、开放和关闭问题
* 创建、编辑和删除问题评论
* 编辑、添加和删除你的标签
* 编写评论时可以预览
* 查看你创建的、分配给你的和提到你的问题
.';ij,i.* 查看版本库问题

### 提交
* 查看提交信息和文件
* 查看文件差异信息
* 查看版本库提交信息

### 更多
* OpenHub正在成长，努力做更好的github客户端。

## 截屏

| 动态 | 侧滑页 | 个人主页 |
|:-:|:-:|:-:|
| ![news](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/news.png?raw=true) | ![drawer](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/drawer.png?raw=true) | ![profile](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/profile.png?raw=true) |

| 版本库主页 | 提交 | 代码 |
|:-:|:-:|:-:|
| ![repo](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/repo.png?raw=true) | ![commit](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/commit.png?raw=true) | ![code](https://raw.githubusercontent.com/ThirtyDegreesRay/OpenHub/master/art/code.png?raw=true) |

## 感谢开源

* [ButterKnife](https://github.com/JakeWharton/butterknife) 视图绑定
* [GreenDao](https://github.com/greenrobot/greenDAO) 一个轻量级而且更快的Android ORM解决方案
* [EventBus](https://github.com/greenrobot/EventBus) 简化Android Activities, Fragments, Threads, Services,等组件之间的通信
* [RxJava](https://github.com/ReactiveX/RxJava) 一个专注于异步编程与控制可观察数据（或者事件）流的API
* [RxAndroid](https://github.com/ReactiveX/RxAndroid) 为了在Android中使用RxJava
* [Retrofit](https://github.com/square/retrofit) 安全的HTTP请求工具库
* [Dagger](https://github.com/google/dagger) 一个快速的依赖注入
* [Glide](https://github.com/bumptech/glide) 一个图像加载和缓存库为了Android中更平滑的滚动
* [code-prettify](https://github.com/google/code-prettify) 代码美化
* [DataAutoAccess](https://github.com/ThirtyDegreesRay/DataAutoAccess) 一个简单的方法去自动存取Android bundle中的数据
* [CircleImageView](https://github.com/vinc3m1/RoundedImageView) 圆形ImageView
* [Toasty](https://github.com/GrenderG/Toasty) 美化的Toast
* [material-about-library](https://github.com/daniel-stoneuk/material-about-library) 让你更容易的创建美丽的关于页面
* [material-dialogs](https://github.com/afollestad/material-dialogs) 一个美丽、流畅的和可自定义的对话框的API
* [GitHub-Trending](https://github.com/thedillonb/GitHub-Trending) 对GitHub趋势页面进行数据抓取
* [RichText](https://github.com/zzhoujay/RichText) Android平台下的富文本解析器，支持Html和Markdown
* [jsoup](https://github.com/jhy/jsoup) HTML解析器
* [OctoDroid](https://github.com/slapperwan/gh4a) GitHub客户端。
* [FastHub](https://github.com/k0shk0sh/FastHub) GitHub客户端。

## 贡献（*按提交时间排序*）
* [moriel5](https://github.com/moriel5) - 希伯来语翻译
* [Henry2o1o](https://github.com/Henry2o1o), [squeezer11](https://github.com/squeezer11), [ropaha](https://github.com/ropaha) - 德语翻译
* [Edfgdz](https://github.com/Edfgdz) - 测试与建议
* [pzhlkj6612](https://github.com/pzhlkj6612) - 改进中文概述的翻译
* [hiteshnayak305](https://github.com/hiteshnayak305) - 印地语翻译
* [KcNirvana](https://github.com/KcNirvana) - 葡萄牙语翻译
* [sclickk](https://github.com/sclickk) - 改进英语翻译
* [Zazsona](https://github.com/Zazsona) - 添加AMOLED主题
* [Aqueminivan](https://github.com/Aqueminivan) - 改进英文概述的翻译
* [XF-zhjnc](https://github.com/XF-zhjnc) - 修复WIKI内部链接点击无效和版本库大小显示溢出等bug
* [fergthh](https://github.com/fergthh) - 西班牙语翻译
* [chiyi4488](https://github.com/chiyi4488) - 繁体中文翻译
* [left4j](https://github.com/left4j) - 俄罗斯语翻译
* [TheParanoik](https://github.com/TheParanoik) - 波兰语翻译
* [X1nto](https://github.com/X1nto) - 格鲁吉亚语语翻译
* [MerkeX](https://github.com/MerkeX) - 意大利语翻译
* [Vistaus](https://github.com/Vistaus) - 荷兰语翻译
* [pkubanek](https://github.com/pkubanek) - 捷克语翻译
* [LouisUnnoficial](https://github.com/LouisUnnoficial) - 葡萄牙语(巴西)翻译

## License
ThirtyDegreesRay:
> Copyright (C) 2017 ThirtyDegreesRay.
> Licensed under the [GPL-3.0](https://www.gnu.org/licenses/gpl.html).
> (See the [LICENSE](https://github.com/ThirtyDegreesRay/OpenHub/blob/master/LICENSE) file for the whole license text.)

Kosh(There are 13 files has some code copied from FastHub):
> Copyright (C) 2017 Kosh.
> Licensed under the [GPL-3.0](https://www.gnu.org/licenses/gpl.html) license.
> (See the [LICENSE](https://github.com/k0shk0sh/FastHub/blob/master/LICENSE) file for the whole license text.)
